--#*****************************************************************************
--#* New File : /mods/gilbotsimprovements/hcpp.lua
--#*
--#* Modded By: Gilbot-X
--#*
--#* Summary  : Used by HCPP so that energy output increases over time.
--#*            It is code from my Exponential Hydrocarbon mod.
--#*
--#*****************************************************************************

local ExtendedAdjacencyUnit = 
    import('/mods/gilbotsimprovements/extendedadjacencyunit.lua').ExtendedAdjacencyUnit

--# This allows dynamic class extension:
--# a class can be used on more than one base class
--# so that various classes can be created with it.
local MakePauseableActiveEffectsUnit = 
    import('/mods/gilbotsimprovements/pauseableactiveeffectsunit.lua').MakePauseableActiveEffectsUnit
local MakeTimeBasedOutputUnit = 
    import('/mods/gilbotsimprovements/timebasedoutputunit.lua').MakeTimeBasedOutputUnit
local BaseClass = 
    MakeTimeBasedOutputUnit(
        MakePauseableActiveEffectsUnit(ExtendedAdjacencyUnit)
    )
    
HydroCarbonPowerPlant = Class(BaseClass) {
    
    --# This is the only line of code that extends
    --# ExtendedAdjacencyUnit in the EnergyCreationUnit class.
    --# Therefore we can treat ourselves as if we extend 
    --# EnergyCreationUnit.
    LandBuiltHiddenBones = {'Floatation'},
    
    --# These variables are constants.  
    ProductionUpdateSeconds = 10,   --Move up to 60 seconds?
    
}
