do --(start of non-destructive hook)
--#****************************************************************************
--#**
--#**  Hook File:  /lua/seraphimunits.lua
--#**  Modded by:  Gilbot-X
--#**
--#**  Summary  :  Unit class generic overrides for Seraphim faction
--#**
--#**  Note: 707 lines in original file so if you get an error 
--#**  subtract 707 from the line number it gives you to find 
--#**  where it is in this hook file.
--#**  
--#****************************************************************************

local ExtendedAdjacencyUnit = 
    import('/mods/gilbotsimprovements/extendedadjacencyunit.lua').ExtendedAdjacencyUnit

--#* 
--#*  Gilbot-X says:
--#*
--#*  All Seraphim defense-weapon structures (such as artillery) extend 
--#*  This class directly from their script files.
--#*
--#** 
SStructureUnit = Class(ExtendedAdjacencyUnit) {}



--#-------------------------------------------------------------
--#  MASS COLLECTION UNITS
--#-------------------------------------------------------------

--#* 
--#*  Gilbot-X says:
--#*
--#*  In the original seraphimunits, when CMassCollectionUnit extends 
--#*  MassCollectionUnit it does not add any extra code.
--#*
--#*  In the original defaultunits.lua, when MassCollectionUnit extends StructureUnit
--#*  with some extra code which I have moved.
--#*
--#**
do --(start of baseclass definition)
local BaseClass = 
    import('/mods/gilbotsimprovements/timebasedmassextractor.lua').TimeBasedMassCollectionUnit
SMassCollectionUnit = Class(BaseClass) {}
end --(end of baseclass definition)




--#-------------------------------------------------------------
--#  ENERGY CREATION UNITS
--#-------------------------------------------------------------

--#*
--#*  Gilbot-X says:
--#*  
--#*  CHydrocarbonPowerPlant extends TimeBasedEnergyCreationUnit
--#*  with all the extra GPG code that CEnergyCreationUnit adds to
--#*  extend EnergyCreationUnit.  So we can use CHydrocarbonPowerPlant
--#*  as a base class for our Aeon HCPP alongside any class that 
--#*  extends the StructureUnit class.
--#*
--#**
local HydroCarbonPowerPlant = 
    import('/mods/gilbotsimprovements/hcpp.lua').HydroCarbonPowerPlant
SHydrocarbonPowerPlant = Class(HydroCarbonPowerPlant) {}





end --(of non-destructive hook)