--#****************************************************************************
--#**
--#**  Hook File:  /units/UAL0001/UAL0001_script.lua
--#**  Author(s):  Gilbot-X
--#**
--#**  Summary  :  Aeon Commander Unit Script
--#**
--#****************************************************************************

local ACUKnowledge = import('/mods/gilbotsimprovements/ACUcommon.lua').ACUKnowledge


local PreviousVersion = UAL0001
UAL0001 = Class(PreviousVersion, ACUKnowledge) {


    --#*
    --#*  Gilbot-X says:
    --#*      
    --#*  I overrided OnCreate so I could 
    --#*  do variable initialization at this time.
    --#** 
    OnCreate = function(self)
        --# Call code from original version first.
        PreviousVersion.OnCreate(self)
       
        --# Perform initialization in new 
        --# second base class 'ACUKnowledge'
        ACUKnowledge.InitializeKnowledge(self)
        
    end,
    
    
    --#*
    --#*  Gilbot-X says:  
    --#* 
    --#*  Had to override this to make sure that 
    --#*  Auto-toggle and ResourceNetworks are not used 
    --#*  when ACU dies.
    --#*
    --#*  This function is defined in Unit.lua
    --#*  and ends by changing state to DeadState
    --#*  so I have to call my extra code before calling
    --#*  the base class code.
    --#**
    OnDestroy = function(self)
        --# Gilbot-X says:  
        --# I added this call so that Auto-toggle
        --# and ResourceNetworks are not used 
        --# when ACU dies.
        ACUKnowledge.CallBefore_OnDestroy(self) 
             
        --# Finally the rest is GPG code.
        PreviousVersion.OnDestroy(self)
    end,
    

}   
    
TypeClass = UAL0001
