--#****************************************************************************
--#**
--#**  Hook File:  /units/URB1104/URB1104_script.lua
--#**
--#**  Modded By:  Gilbot-X
--#**
--#**  Summary  :  Cybran Mass Fabricator
--#**              Modded because my autotoggle code was shutting 
--#**              off the unit before it had a chance to create its rotator.
--#**
--#****************************************************************************
local CMassFabricationUnit = import('/lua/cybranunits.lua').CMassFabricationUnit

URB1104 = Class(CMassFabricationUnit) {
    DestructionPartsLowToss = {'Blade',},

    OnStopBeingBuilt = function(self,builder,layer)
        CMassFabricationUnit.OnStopBeingBuilt(self,builder,layer)
        self.Rotator = CreateRotator(self, 'Blade', 'z')
        self.Trash:Add(self.Rotator)
        self.Rotator:SetAccel(40)
        self.Rotator:SetTargetSpeed(150)
    end,
    
    OnProductionUnpaused = function(self)
        CMassFabricationUnit.OnProductionUnpaused(self)
        self.Rotator:SetTargetSpeed(150)
    end,
    
    OnProductionPaused = function(self)
        CMassFabricationUnit.OnProductionPaused(self)
        --# Gilbot-X: I had to put a safety check here because
        --# autotoggle was shutting off the unit before it
        --# had a chance to create its rotator.
        if self.Rotator then self.Rotator:SetTargetSpeed(0) end
    end,
}

TypeClass = URB1104