--#****************************************************************************
--#*
--#*  Hook File:  /units/XSB1102/XSB1102_script.lua
--#*
--#*  Modded by:  Gilbot-X
--#*
--#*  Summary  :  Seraphim Hydrocarbon Power Plant Script
--#*
--#****************************************************************************

local SHydrocarbonPowerPlant = 
    import('/lua/seraphimunits.lua').SHydrocarbonPowerPlant
    
XSB1102 = Class(SHydrocarbonPowerPlant) {

    --#*
    --#*  Gilbot-X says:
    --#*  
    --#*  Initialisation.
    --#**
    OnCreate = function(self,builder,layer)
        --# Call base class version first
        SHydrocarbonPowerPlant.OnCreate(self)
        
        --# This table overrides one from the the MaintenanceConsumption Mod
        --# which declares/instantiates this table variable in a hook of unit.lua .
        --# The mod uses this table to keep track of how many types of intel are active.
        self.EnabledResourceDrains = {
            Stealth = false,
            Cloak = false,
        }
    end,
    
        
    --#*
    --#*  Gilbot-X says:
    --#*  
    --#*  Override this with  code that will be done after the unit 
    --#*  has been built but before the first state is changed
    --#*  in a structure unit that uses states.
    --#**
    DoBeforeAnyStateChanges = function(self)
        --# Do base class versions first
        SHydrocarbonPowerPlant.DoBeforeAnyStateChanges(self)
        
        --# This turns off the toggles for cloak and stealth
        self:SetScriptBit('RULEUTC_CloakToggle', true)
        self:SetScriptBit('RULEUTC_StealthToggle', true)
    end,
    
}

TypeClass = XSB1102