name = "Gilbot-X's Core Mod"
uid = "28e031d0-abb4-4bf6-9236-451244fa8029"

version = 1.1
description = "A selection of improvements from Gilbot-X."
copyright = "Redevelop and re-release as much as you want but give me credit!"
author = "Gilbot-X"
url = "http://forums.gaspowered.com/viewtopic.php?p=???????"

after = {
    "58c59172-6074-4efa-b0c3-f900bd68ffa3"  -- Gilbot-X's 'Unit-Icons-in-one-folder' Mod
}  

         
before = {
    "138c2183-d36c-4b99-92b3-fa65d95442a5", -- Gilbot-X's Exponential Mass Mod
    "46235653-5cdf-4a00-8b61-c1fb9354330e", -- Gilbot-X's Exponential HCPP Mod
    "b667fefc-e1cb-4975-8e3a-d1e5382a271d", -- Gilbot-X's Aeon Shield Pod Artillery Mod
    "668180a2-57cd-4530-a3a2-0bc66e315dfc"  -- Gilbot-X's T4 Powergen Mod
}

conflicts = {
    "0840B9B8-0828-11DC-BED6-CDB655D89593", -- Pipeline Mod from Lakitrid
    "682502bb-fa3e-4265-addd-67d3b85c5976", -- Gilbot-X's Adjacency Extension v1.2
    "4bfebf8f-fa9a-41ca-85b2-80b8f25a0ac5", -- Gilbot-X's Maintenance Consumption Breakdown v1.5-
    "4bfebf8f-fa9a-41ca-85b2-80b8f25a0ac7", -- Gilbot-X's Maintenance Consumption Breakdown v1.6+
    "6268bea8-220f-11dc-8314-0800200c9a66", -- Automatic Mass Fabricators Mod
    "9998bea8-220f-11dc-8314-0800200c9a66", -- Gilbot-X's Automatic Radar Mod
    "559eb7c3-1e98-4055-9684-cb8a1045f7fd", -- Gilbot-X's Factory Toggles Mod
    "9e411038-7c8f-427e-bcf0-0a96d34aacff", -- Gilbot-X's All-Purpose Slider Controls
    "4f115984-4667-4b24-8115-1b2b4188b300", -- Covert Jaguar's Transparent Cloak 3
}

requires = {
    "58c59172-6074-4efa-b0c3-f900bd68ffa3"  -- Gilbot-X's 'Unit-Icons-in-one-folder' Mod
}
requiresNames = {
    ["58c59172-6074-4efa-b0c3-f900bd68ffa3"] = 
        "Icons Mod: Gilbot-X's 'put unit-icons-in-one-folder' Mod",
}

enabled = true
exclusive = false
ui_only = false
selectable = true


--[[==============================================================================================
Mod Description from GPGNet:
(see url= 
 http://forums.gaspowered.com/viewtopic.php?t=21812 
 for most up-to-date version)
================================================================================================== 

The major new feature in this mod is my 'Resource Networks' system. 

The 'Resource Networks' System 
--------------------------------------- 
This is a step further for my work on extending range of adjacency bonuses (a WIP I made available on RTSC last June). With the addition of some code from Lakitrid's Pipelines mod, and a lot of new features and aesthetic improvements, I've made an adjacency system that is far superior to either of the original two that inspired it. 

Now you can use pipelines at up to 4 Tech levels to link up networks of structures that propagate bonuses throughout the network. 


The T1 pipelines must be built next to each other. They are easily destroyed and blow up in a chain reaction. 

The T2 pipelines are armoured and can remotely connect to other pipeline units up to a few O-grids away. 

The T3 pipelines are heavily armoured and can remotely connect to other pipeline units up to 20 O-grids away. 

Cybran faction has an Experimental Pipeline generated by a base that disguises itself as a T1 wall piece. It only connects other pipelines to each other, but it has a massive range and the base is heavily armoured.

All connections between structure units also form part of the resource network. Currently the networks are capped so that units attached to a network can get at most a 50% boost in resource production, and at most a 50% reduction in running costs. This can be changed easily and I'm curious to what you players out there will prefer. 

You can use a slider control (ALT-R) to adjust the range of T2/T3/T4 pipelines. There is a small energy cost associated with the range increases (but costs are still much smaller than the potential benefits). In a large network, reducing the amount of mass it takes any factory to build anything by 50% is worth spending some energy on. 

Just using T1 pipelines is very simple (using dragbuild to lay the pipeline) but setting up T2/T3/T4 pipelines takes an initial bit of planning and micromanagement to set correct positions and get maximum efficiency (i.e you can intersperse them with T1 pipelines for maximum efficiency but then the link is easier for the enemy to cut as T1 pipelines have weaker armour). So there is a 'planning and building time' cost in using them, as well as the initial investment in mass and energy you need to build them. Using pipelines to link your main base to a firebase will also lead a trail to your main base. You have to decide if (and how) using pipelines is going to suit your strategy. 

The ACU is responsible for the distribution of resources through these networks. Without the ACU, units on a network cannot receive the right bonus. As a result, if your ACU dies, all of your network links and pipeline units will instantaneously be destroyed and no more network links will be created. This will make your ACU a more special unit and more important to keep alive. 


-------------------------- 
Your ACU can switch other units on and off automatically: 

This is my new 'Prioritised Auto-toggle' mod that I have released bundled with this mod-pack. All units consuming resources (i.e. massfabs, intel units, stealth, etc) are switched off automatically to prevent your economy from stalling. Initially, the order they are switched off in is in the order of priority defined in the mod. Mass fabs are switched off first, then radar and sonar, then counter-intel, mobile shields, and finally shield towers are switched off last. Units are ordered within these groups according to tech-level. Other units have their own specific priorities in this ladder. Your ACU will also switch all of these units back on when you have enough energy to run them, and the order it does this reflects the same priority order that was used to switch them off, i.e. if everything was switched off, then shield towers get switched back on first, etc. All units capable of being included in the ACU's auto-toggle list will also have a toggle that allows them to opt in or out of the list. This is useful if you have a unit like a stealth tower that you don't want the ACU to ever shut off - i.e. you would rather your energy hit rock bottom and construction was effected rather than have it switched off. 

New: You can now customise the order in which things are switched off ingame by selecting an auto-toggle unit and pressing CTRL-NUMPADMINUS and CTRL-NUMPADPLUS (i.e. like how you would change the game speed but with CTRL also pressed). The order number on the units will change to reflect the new order. I've used the custom naming system to display these order numbers to the player. Press CTRL-NUMPADSTAR to toggle this display on/off. 

This mod reduces micromanagement, but if your ACU dies, you lose the ability and everything is back on manual. 


-------------------------- 
New type of adjacency bonus: 

Aeon faction now has an Experimental Shield Enhancer that can be attached to a network. It can increase the amount of damage any shield can take, from as low as a 10% increase up to 100% increase depending on power settings (set with slider control). It consumes a lot of power at its top setting. It is also one of the units that your ACU will automatically switch off to prevent the economy running out of energy. 


-------------------------- 
Some of my other recent game mods included in the ModPack: 


1/ My popular 'Exponential Hydrocarbon Power Plants' mod version 2. 
2/ My version of the 'Exponential Mass' mod 
...(with auto-packing Aeon mex, stealth on Cybran). 
3/ My recent 'All-purpose Slider Controls' mod. 
4/ My 'Factory Toggles' mod 
...(so you can choose how toggles are set on units as they roll out of the factory). 
5/ My version of the 'Aeon Czar Buff' mod 
...(with slider control that lets you adjust personal shield strength)


-------------------------- 
I've also included the latest versions of the following two mods which I made (back in May this year) for many of my other mods to use:
1/ My 'Enhancement Slot Names' mod. 
2/ My 'Maintenance Consumption Breakdown' mod. 
These mods both have modular script code that make unit mods easier to program and maintain. The player won't really notice the effect of these but having them included means you can run all my other added unit mods without also downloading these separately. 


-------------------------- 
The following mods from other people are included in my ModPack (with minor changes), because I like these mods and I wanted to ensure compatibility with my ModPack: 


1/ Duncane's 'Music Order' mod. 
2/ CovertJaguar's 'TransparentCloak3' mod. 
3/ Goom's 'Area Commands' mod.
If there are other mods you want this to be made compatible with, please let me know. I'm thinking of testing for compatibility with Neruz's Modular Damage mod soon, and if you are in a modding team, I can help you integrate my code with yours if you want. 

-------------------------- 
At the moment I'm doing some final debugging and beta testing but I hope to release it on RTSC this week. I'm considering bundling my 'T4 Power Generators' mod with this, and maybe some other cool mod stuff I've done that nobody else (to my knowledge) has done. 

Here's the link to download the Beta: 
http://www.rtscommunity.com/mw/modification.php?itemid=186&game=35 

-------------------------- 
Installation: 

On Windows Vista, place it in 

"C:\Users\(your user name)\Documents\My Games\Gas Powered Games\SupremeCommander\mods\" 

On Windows XP it is something slightly different but similar. Instead of 
"C:\Users\(your user name)\Documents\" it's whatever folder opens when you click on 'My Documents' in Windows Explorer. I've altered all my mods to be run as zip files placed in this folder.


-------------------------- 
How To Use New Controls: 

1/ To use a unit's slider controls: 

        select unit and press [ALT-R]
        then...
        (Drag slider to adjust value)
        (Click on OK to accept new value)  
           --Note that the 'Hit-test' on this button is still a bit poor
             so becareful when clicking on it)
        (Unselect unit to cancel slider control without setting new value)
    
2/ To show/hide priority list order numbers on all autotoggle units: 

        press [CTRL-NumStar] 
    
3/ To increase priority list order number of an autotoggle unit: 

        select unit and press [CTRL-NumPlus] 
    
4/ To decrease priority list order number of an autotoggle unit: 

        select unit and press [CTRL-NumMinus] 
    
5/ To show/hide network ID numbers on all units in networks: 

        press [CTRL-NumSlash]

6/ To create a rectangular area-command (using Goom's Area Commands mod which I included):

        press [X]
        (press [X] again to change command issued)

        
        
        
-------------------------- 
Thank-you for downloading!!

Gilbot-X 

]]