MyIconPath = "/mods/Unit Icons"

local MyUnitIdTable = {
    uaa0309= 'uaa0309',
    ura0309= 'ura0309',
    ura0409= 'ura0409',
    xaa0307= 'xaa0307',
    xal0309= 'xal0309',
    xab2306= 'xab2306',
    xeb5205= 'xeb5205',
    xel0307= 'xel0307',
    xel0308= 'xel0308',
    xel0309= 'xel0309',
    xes0402= 'xes0402',
    xrb2306= 'xrb2306',
    xrb5205= 'xrb5205',
    xrl0205= 'xrl0205',
    xrl0307= 'xrl0307',
    xrl0308= 'xrl0308',
    xrl0309= 'xrl0309',
    xrs0304= 'xrs0304',
    xrs0305= 'xrs0305',
    xrs0402= 'xrs0402',
    xrl0006= 'xrl0006',
    xsb2402= 'xsb2402',
    xsb0405= 'xsb0405',
    xsa0108= 'xsa0108',
    xsl0306= 'xsl0306',
    --# My units
    ual0101b ='ual0101',
    ual0101c ='ual0101',
    uel0106b ='uel0106',
    uel0106c ='uel0106',
    uel0106d ='uel0106',
    uel0111b ='uel0111',
    uel0111c ='uel0111',
    --# T4 Powergens
    uab1301b= 'uab1301',
    urb1201b= 'urb1201',
    urb1301b= 'urb1301',
    uec1901b= 'uec1901',
    --# T3 mobile shield
    uel0307b ='uel0307',
    --# T2 sniper tank
    uel0103b ='uel0103',
    --# Pipelines
    gab5101 ='gab5101',
    gab5201 ='gab5201',
    gab5301 ='gab5301',
    geb5101 ='geb5101',
    geb5201 ='geb5201',
    geb5301 ='geb5301',
    grb5101 ='grb5101',
    grb5201 ='grb5201',
    grb5301 ='grb5301',
    grb5301b ='grb5301',
    urb5101g= 'urb5101g',
    --# Shield strengthener
    uac1401b ='uac1401',
    --# Aeon FARK
    ual0301b= 'ual0301b',
}

function IsMyUnit(bpid)
    for myUnitId, iconID in MyUnitIdTable do
       if myUnitId == bpid then
          return iconID
       end
    end
    return false
end



--#*
--#* Called from file /lua/ui/uiutil.lua
--#*
--#* The argument filespec is the filename of format '/icons/units/*_icon.dds'
--#*
--#**
function GetFileNameAndCheckExists(filespec)
    for myUnitID, myIconID in MyUnitIdTable do
        if string.find(filespec, myUnitID .. '_icon') then
          local iconPath = MyIconPath .. string.gsub(filespec, myUnitID, myIconID,1)
          if DiskGetFileInfo(iconPath) then
             return iconPath
          else
             WARN('Icon file '.. repr(iconPath) 
               ..' could not be found, check your file path and icon names!')
             return nil
          end
        end
    end
    return nil
end