do --(start of non-destructive hook)
--#****************************************************************************
--#**
--#**  Hook File:  /lua/SimCallbacks.lua
--#**  Modded by:  Gilbot-X, with code from Neruz and Goom
--#**
--#**  Summary  :  
--#**
--#**  This module contains the Sim-side lua functions that can be invoked
--#**  from the user side.  These need to validate all arguments against
--#**  cheats and exploits.
--#**
--#**  We store the callbacks in a sub-table (instead of directly in the
--#**  module) so that we don't include any.
--#**  
--#***************************************************************************


--#*
--#*  Gilbot-X says:  
--#*  These are part of Goom's area commands mod.
--#**
Callbacks.AreaCommandCallback = 
    import('/mods/gilbotsimprovements/areacommands.lua').AreaCommand
Callbacks.DrawRectangle = 
    import('/mods/gilbotsimprovements/areacommands.lua').DrawRectangle


--#*
--#*  Gilbot-X says:  
--#*  These callbacks are for my slider control menu.
--#**
Callbacks.SetShieldSize =
    import('/mods/gilbotsimprovements/statslidercallbacks.lua').SetShieldSizeCallback
Callbacks.SetStatValue = 
    import('/mods/gilbotsimprovements/statslidercallbacks.lua').SetStatValueCallback
    
    
--#*
--#*  Gilbot-X says:  
--#*  These callbacks are for my auto-toggle system.
--#**
Callbacks.DecreaseAutoTogglePriority = 
    import('/mods/gilbotsimprovements/autotogglecallbacks.lua').DecreasePriorityCallback
Callbacks.IncreaseAutoTogglePriority = 
    import('/mods/gilbotsimprovements/autotogglecallbacks.lua').IncreasePriorityCallback
Callbacks.ToggleAutoTogglePriorityDisplay = 
    import('/mods/gilbotsimprovements/autotogglecallbacks.lua').TogglePriorityDisplayCallback    
   
   
--#*
--#*  Gilbot-X says:  
--#*  These callbacks are for debugging my Resource Network system.
--#**
Callbacks.ToggleNetworkDisplay = 
    import('/mods/gilbotsimprovements/resourcenetworkcallbacks.lua').ToggleNetworkDisplayCallback     
    

--#*
--#*  Gilbot-X says:  
--#*  These callbacks are for general debugging.
--#**
Callbacks.ToggleEntityDisplay = 
    import('/mods/gilbotsimprovements/debuggingcallbacks.lua').ToggleEntityDisplayCallback    

--#*
--#*  Gilbot-X says:  
--#*  These callbacks are for debugging shields and
--#*  the Aeon shield strength enhancer
--#**
Callbacks.ToggleShieldStrengthDisplay = 
    import('/mods/gilbotsimprovements/debuggingcallbacks.lua').ToggleShieldStrengthDisplayCallback     

--#*
--#*  Gilbot-X says:  
--#*  These callbacks are for debugging shields and
--#*  the Aeon shield strength enhancer
--#**
Callbacks.ToggleRateOfFireDisplay = 
    import('/mods/gilbotsimprovements/debuggingcallbacks.lua').ToggleRateOfFireDisplayCallback     
           
    
    
end --(of non-destructive hook)